const express = require("express");
const mysql = require("mysql2");
const Joi = require("joi")
const sqlCon = require("../db/sqlConnect")
const router = express.Router();

// let query = "'nba'; Delete...."
// query = mysql.escape(query)
// console.log(query);

router.get("/", async (req, res) => {
  // ?perPage = 
  const perPage = Number(req.query.perPage) || 5;
  const page = Number(req.query.page - 1) || 0;
  const skip = page * perPage;
  const category = mysql.escape(req.query.category);

  let where = "";
  if (category != "NULL") {
    where += `WHERE sports = ${category}`
  }

  const myQuery = `SELECT * FROM players ${where} LIMIT ${skip},${perPage}`;
  sqlCon.query(myQuery, (err, results, fields) => {
    if (err) { return res.status(502).json({ err }) }
    // res.json({results,fields});
    res.json(results);
  })

})

router.post("/", async (req, res) => {
  const validBody = this.validatePlayer(req.body);
  if(validBody.error){
    return res.status(400).json(validBody.error.details);
  }
  // req.body.name = mysql.escape(req.body.name)
  const myQuery = `INSERT INTO players 
  VALUES (null,?,?,?)`
  const { name, birth_year, sports } = req.body;
  sqlCon.query(myQuery, [name, birth_year, sports], (err, results, fields) => {
    if (err) { return res.status(502).json({ err }) }
    // res.json({results,fields});
    res.json(results);
  })
})

router.put("/:id", async (req, res) => {
  const validBody = this.validatePlayer(req.body);
  if(validBody.error){
    return res.status(400).json(validBody.error.details);
  }
  const id = Number(req.params.id);
  const myQuery = `UPDATE players SET name = ? , birth_year = ? , sports = ? WHERE id = ${id}`
  const { name, birth_year, sports } = req.body;
  sqlCon.query(myQuery, [name, birth_year, sports], (err, results, fields) => {
    if (err) { return res.status(502).json({ err }) }
    // res.json({results,fields});
    res.json(results);
  })
})

router.delete("/:id", async (req, res) => {
  const id = Number(req.params.id);
  const myQuery = `DELETE FROM players WHERE id = ${id}`;
  sqlCon.query(myQuery, (err, results, fields) => {
    if (err) { return res.status(502).json({ err }) }
    // res.json({results,fields});
    res.json(results);
  })
})


exports.validatePlayer = (_reqBody) => {
  let joiSchema = Joi.object({
    name: Joi.string().min(2).max(100).required(),
    birth_year: Joi.number().min(1900).max(2100).required(),
    sports: Joi.string().min(2).max(100).required(),
  })
  return joiSchema.validate(_reqBody)
}

module.exports = router;